package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.FencePointServiceI;
import com.zcloud.personnel.positioning.dto.FencePointAddCmd;
import com.zcloud.personnel.positioning.dto.FencePointPageQry;
import com.zcloud.personnel.positioning.dto.FencePointUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.FencePointCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "人员定位围栏坐标点")
@RequestMapping("/${application.gateway}/fencePoint")
@RestController
@AllArgsConstructor
public class FencePointController {
    private final FencePointServiceI fencePointService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<FencePointCO> add(@Validated @RequestBody FencePointAddCmd cmd) {
        fillCorpinfo(cmd);
        return fencePointService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<FencePointCO> page(@RequestBody FencePointPageQry qry) {
        return fencePointService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<FencePointCO> listAll() {
        return MultiResponse.of(fencePointService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<FencePointCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(fencePointService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        fencePointService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        fencePointService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody FencePointUpdateCmd cmd) {
        fillCorpinfo(cmd);
        fencePointService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(FencePointAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(FencePointUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
